GDCM: gdcm::MediaStorage Class Reference

GDCM 3.2.10

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Friends | List of all members
gdcm::MediaStorage Class Reference

MediaStorage. More...

`#include <gdcmMediaStorage.h>`

## Public Types
enum | MSType { MediaStorageDirectoryStorage = 0 , ComputedRadiographyImageStorage , DigitalXRayImageStorageForPresentation , DigitalXRayImageStorageForProcessing , DigitalMammographyImageStorageForPresentation , DigitalMammographyImageStorageForProcessing , DigitalIntraoralXrayImageStorageForPresentation , DigitalIntraoralXRayImageStorageForProcessing , CTImageStorage , EnhancedCTImageStorage , UltrasoundImageStorageRetired , UltrasoundImageStorage , UltrasoundMultiFrameImageStorageRetired , UltrasoundMultiFrameImageStorage , MRImageStorage , EnhancedMRImageStorage , MRSpectroscopyStorage , NuclearMedicineImageStorageRetired , SecondaryCaptureImageStorage , MultiframeSingleBitSecondaryCaptureImageStorage , MultiframeGrayscaleByteSecondaryCaptureImageStorage , MultiframeGrayscaleWordSecondaryCaptureImageStorage , MultiframeTrueColorSecondaryCaptureImageStorage , StandaloneOverlayStorage , StandaloneCurveStorage , LeadECGWaveformStorage , GeneralECGWaveformStorage , AmbulatoryECGWaveformStorage , HemodynamicWaveformStorage , CardiacElectrophysiologyWaveformStorage , BasicVoiceAudioWaveformStorage , StandaloneModalityLUTStorage , StandaloneVOILUTStorage , GrayscaleSoftcopyPresentationStateStorageSOPClass , XRayAngiographicImageStorage , XRayRadiofluoroscopingImageStorage , XRayAngiographicBiPlaneImageStorageRetired , NuclearMedicineImageStorage , RawDataStorage , SpacialRegistrationStorage , SpacialFiducialsStorage , PETImageStorage , RTImageStorage , RTDoseStorage , RTStructureSetStorage , RTPlanStorage , CSANonImageStorage , Philips3D , EnhancedSR , BasicTextSR , HardcopyGrayscaleImageStorage , ComprehensiveSR , DetachedStudyManagementSOPClass , EncapsulatedPDFStorage , EncapsulatedCDAStorage , StudyComponentManagementSOPClass , DetachedVisitManagementSOPClass , DetachedPatientManagementSOPClass , VideoEndoscopicImageStorage , GeneralElectricMagneticResonanceImageStorage , GEPrivate3DModelStorage , ToshibaPrivateDataStorage , MammographyCADSR , KeyObjectSelectionDocument , HangingProtocolStorage , ModalityPerformedProcedureStepSOPClass , PhilipsPrivateMRSyntheticImageStorage , VLPhotographicImageStorage , SegmentationStorage , RTIonPlanStorage , XRay3DAngiographicImageStorage , EnhancedXAImageStorage , RTIonBeamsTreatmentRecordStorage , SurfaceSegmentationStorage , VLWholeSlideMicroscopyImageStorage , RTTreatmentSummaryRecordStorage , EnhancedUSVolumeStorage , XRayRadiationDoseSR , VLEndoscopicImageStorage , BreastTomosynthesisImageStorage , FujiPrivateCRImageStorage , OphthalmicPhotography8BitImageStorage , OphthalmicTomographyImageStorage , VLMicroscopicImageStorage , EnhancedPETImageStorage , VideoPhotographicImageStorage , XRay3DCraniofacialImageStorage , IVOCTForPresentation , IVOCTForProcessing , LegacyConvertedEnhancedCTImageStorage , LegacyConvertedEnhancedMRImageStorage , LegacyConvertedEnhancedPETImageStorage , BreastProjectionXRayImageStorageForPresentation , BreastProjectionXRayImageStorageForProcessing , HardcopyColorImageStorage , EnhancedMRColorImageStorage , FujiPrivateMammoCRImageStorage , OphthalmicPhotography16BitImageStorage , VideoMicroscopicImageStorage , MS_END }
enum | ObjectType { NoObject = 0 , Video , Waveform , Audio , PDF , URI , Segmentation , ObjectEnd }

## Public Member Functions
| MediaStorage (MSType type=MS_END)
const char * | GetModality () const
unsigned int | GetModalityDimension () const
const char * | GetString () const
| Return the Media String of the object.
void | GuessFromModality (const char *modality, unsigned int dimension=2)
bool | IsUndefined () const
| operator MSType () const
bool | SetFromDataSet (DataSet const &ds)
bool | SetFromFile (File const &file)
bool | SetFromHeader (FileMetaInformation const &fmi)
bool | SetFromModality (DataSet const &ds)

## Static Public Member Functions
static const char * | GetMSString (MSType ts)
| Return the Media String associated. Will return NULL for MS_END.
static MSType | GetMSType (const char *str)
static unsigned int | GetNumberOfModality ()
static unsigned int | GetNumberOfMSString ()
static unsigned int | GetNumberOfMSType ()
static bool | IsImage (MSType ts)

## Protected Member Functions
void | SetFromSourceImageSequence (DataSet const &ds)

## Friends
std::ostream & | operator<< (std::ostream &os, const MediaStorage &ms)

## Detailed Description

MediaStorage.

Note
  FIXME There should not be any notion of Image and/or PDF at that point Only the codec can answer yes I support this Media Storage or not... For instance an ImageCodec will answer yes to most of them while a PDFCodec will answer only for the Encapsulated PDF

See also
  UIDs

Examples
  CreateJPIPDataSet.cxx, EncapsulateFileInRawData.cxx, Extracting_All_Resolution.cxx, Fake_Image_Using_Stream_Image_Writer.cxx, GenAllVR.cxx, GenFakeIdentifyFile.cxx, GenerateStandardSOPClasses.cxx, GetSubSequenceData.cxx, MpegVideoInfo.cs, ReadAndDumpDICOMDIR.cxx, ReadAndDumpDICOMDIR2.cxx, StreamImageReaderTest.cxx, TemplateEmptyImage.cxx, TestReader.cxx, gdcmrtionplan.cxx, gdcmrtplan.cxx, and iU22tomultisc.cxx.

## Member Enumeration Documentation

## ◆ MSType

enum gdcm::MediaStorage::MSType

Enumerator
MediaStorageDirectoryStorage |
ComputedRadiographyImageStorage |
DigitalXRayImageStorageForPresentation |
DigitalXRayImageStorageForProcessing |
DigitalMammographyImageStorageForPresentation |
DigitalMammographyImageStorageForProcessing |
DigitalIntraoralXrayImageStorageForPresentation |
DigitalIntraoralXRayImageStorageForProcessing |
CTImageStorage |
EnhancedCTImageStorage |
UltrasoundImageStorageRetired |
UltrasoundImageStorage |
UltrasoundMultiFrameImageStorageRetired |
UltrasoundMultiFrameImageStorage |
MRImageStorage |
EnhancedMRImageStorage |
MRSpectroscopyStorage |
NuclearMedicineImageStorageRetired |
SecondaryCaptureImageStorage |
MultiframeSingleBitSecondaryCaptureImageStorage |
MultiframeGrayscaleByteSecondaryCaptureImageStorage |
MultiframeGrayscaleWordSecondaryCaptureImageStorage |
MultiframeTrueColorSecondaryCaptureImageStorage |
StandaloneOverlayStorage |
StandaloneCurveStorage |
LeadECGWaveformStorage |
GeneralECGWaveformStorage |
AmbulatoryECGWaveformStorage |
HemodynamicWaveformStorage |
CardiacElectrophysiologyWaveformStorage |
BasicVoiceAudioWaveformStorage |
StandaloneModalityLUTStorage |
StandaloneVOILUTStorage |
GrayscaleSoftcopyPresentationStateStorageSOPClass |
XRayAngiographicImageStorage |
XRayRadiofluoroscopingImageStorage |
XRayAngiographicBiPlaneImageStorageRetired |
NuclearMedicineImageStorage |
RawDataStorage |
SpacialRegistrationStorage |
SpacialFiducialsStorage |
PETImageStorage |
RTImageStorage |
RTDoseStorage |
RTStructureSetStorage |
RTPlanStorage |
CSANonImageStorage |
Philips3D |
EnhancedSR |
BasicTextSR |
HardcopyGrayscaleImageStorage |
ComprehensiveSR |
DetachedStudyManagementSOPClass |
EncapsulatedPDFStorage |
EncapsulatedCDAStorage |
StudyComponentManagementSOPClass |
DetachedVisitManagementSOPClass |
DetachedPatientManagementSOPClass |
VideoEndoscopicImageStorage |
GeneralElectricMagneticResonanceImageStorage |
GEPrivate3DModelStorage |
ToshibaPrivateDataStorage |
MammographyCADSR |
KeyObjectSelectionDocument |
HangingProtocolStorage |
ModalityPerformedProcedureStepSOPClass |
PhilipsPrivateMRSyntheticImageStorage |
VLPhotographicImageStorage |
SegmentationStorage |
RTIonPlanStorage |
XRay3DAngiographicImageStorage |
EnhancedXAImageStorage |
RTIonBeamsTreatmentRecordStorage |
SurfaceSegmentationStorage |
VLWholeSlideMicroscopyImageStorage |
RTTreatmentSummaryRecordStorage |
EnhancedUSVolumeStorage |
XRayRadiationDoseSR |
VLEndoscopicImageStorage |
BreastTomosynthesisImageStorage |
FujiPrivateCRImageStorage |
OphthalmicPhotography8BitImageStorage |
OphthalmicTomographyImageStorage |
VLMicroscopicImageStorage |
EnhancedPETImageStorage |
VideoPhotographicImageStorage |
XRay3DCraniofacialImageStorage |
IVOCTForPresentation |
IVOCTForProcessing |
LegacyConvertedEnhancedCTImageStorage |
LegacyConvertedEnhancedMRImageStorage |
LegacyConvertedEnhancedPETImageStorage |
BreastProjectionXRayImageStorageForPresentation |
BreastProjectionXRayImageStorageForProcessing |
HardcopyColorImageStorage |
EnhancedMRColorImageStorage |
FujiPrivateMammoCRImageStorage |
OphthalmicPhotography16BitImageStorage |
VideoMicroscopicImageStorage |
MS_END |

Examples
  GenerateStandardSOPClasses.cxx, and MpegVideoInfo.cs.

## ◆ ObjectType

enum gdcm::MediaStorage::ObjectType

Enumerator
NoObject |
Video |
Waveform |
Audio |
PDF |
URI |
Segmentation |
ObjectEnd |

## Constructor & Destructor Documentation

## ◆ MediaStorage()

gdcm::MediaStorage::MediaStorage | ( | MSType | type = MS_END | ) |
| inline

References MS_END.

Referenced by GuessFromModality(), and operator<<.

## Member Function Documentation

## ◆ GetModality()

const char * gdcm::MediaStorage::GetModality | ( |  | ) | const

## ◆ GetModalityDimension()

unsigned int gdcm::MediaStorage::GetModalityDimension | ( |  | ) | const

## ◆ GetMSString()

const char * gdcm::MediaStorage::GetMSString | ( | MSType | ts | ) |
| static

Return the Media String associated. Will return NULL for MS_END.

Examples
  GenerateStandardSOPClasses.cxx.

Referenced by operator<<.

## ◆ GetMSType()

MSType gdcm::MediaStorage::GetMSType | ( | const char * | str | ) |
| static

Examples
  MetaImageMD5Activiz.cs, and TestReader.cxx.

## ◆ GetNumberOfModality()

unsigned int gdcm::MediaStorage::GetNumberOfModality | ( |  | ) |
| static

## ◆ GetNumberOfMSString()

unsigned int gdcm::MediaStorage::GetNumberOfMSString | ( |  | ) |
| static

## ◆ GetNumberOfMSType()

unsigned int gdcm::MediaStorage::GetNumberOfMSType | ( |  | ) |
| static

## ◆ GetString()

const char * gdcm::MediaStorage::GetString | ( |  | ) | const

Return the Media String of the object.

Examples
  CreateJPIPDataSet.cxx, EncapsulateFileInRawData.cxx, Fake_Image_Using_Stream_Image_Writer.cxx, GetSubSequenceData.cxx, MpegVideoInfo.cs, StreamImageReaderTest.cxx, TemplateEmptyImage.cxx, and iU22tomultisc.cxx.

## ◆ GuessFromModality()

void gdcm::MediaStorage::GuessFromModality | ( | const char * | modality,
|  | unsigned int | dimension = 2 )

References MediaStorage(), and operator<<.

## ◆ IsImage()

bool gdcm::MediaStorage::IsImage | ( | MSType | ts | ) |
| static

Returns whether DICOM has a Pixel Data element (7fe0,0010)

Warning
  MRSpectroscopyStorage could be image but are not

Examples
  MetaImageMD5Activiz.cs.

## ◆ IsUndefined()

bool gdcm::MediaStorage::IsUndefined | ( |  | ) | const
| inline

Examples
  TestReader.cxx.

References MS_END.

## ◆ operator MSType()

gdcm::MediaStorage::operator MSType | ( |  | ) | const
| inline

## ◆ SetFromDataSet()

bool gdcm::MediaStorage::SetFromDataSet | ( | DataSet const & | ds | ) |

Advanced user only (functions should be protected level...) Those function are lower level than SetFromFile

## ◆ SetFromFile()

bool gdcm::MediaStorage::SetFromFile | ( | File const & | file | ) |

Attempt to set the MediaStorage from a file: WARNING: When no MediaStorage & Modality are found BUT a PixelData element is found then MediaStorage is set to the default SecondaryCaptureImageStorage (return value is false in this case)

Examples
  ReadAndDumpDICOMDIR.cxx, ReadAndDumpDICOMDIR2.cxx, TestReader.cxx, gdcmrtionplan.cxx, and gdcmrtplan.cxx.

## ◆ SetFromHeader()

bool gdcm::MediaStorage::SetFromHeader | ( | FileMetaInformation const & | fmi | ) |

## ◆ SetFromModality()

bool gdcm::MediaStorage::SetFromModality | ( | DataSet const & | ds | ) |

## ◆ SetFromSourceImageSequence()

void gdcm::MediaStorage::SetFromSourceImageSequence | ( | DataSet const & | ds | ) |
| protected

## Friends And Related Symbol Documentation

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | os,
|  | const MediaStorage & | ms )
| friend

References MediaStorage(), GetMSString(), and operator<<.

Referenced by GuessFromModality(), and operator<<.

The documentation for this class was generated from the following file:

- gdcmMediaStorage.h